/* 
 * Copyright (C) 1999  John Olsson
 * Copyright (C) 2005  Gregor Richards
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv)
{
    int x, w, y, h;
    int yi, hi;
    FILE *fin, *fout;
    
    char line[10240];
    line[10239] = '\0';
    
    if (argc < 2) {
        fprintf(stderr, "Use: chunk <input file> [output file [x [y [w [h]]]]]\n");
        return 1;
    }
    
    fin = fopen(argv[1], "rb");
    if (!fin) { perror(argv[1]); return 1; }
    
    if (argc >= 3) {
        fout = fopen(argv[2], "wb");
        if (!fout) { perror(argv[2]); return 1; }
    } else {
        fout = stdout;
    }
    
    if (argc >= 4) {
        x = atoi(argv[3]);
    } else {
        fprintf(stderr, "Starting X: ");
        scanf("%d", &x);
    }
    
    if (argc >= 5) {
        y = atoi(argv[4]);
    } else {
        fprintf(stderr, "Starting Y: ");
        scanf("%d", &y);
    }
    
    if (argc >= 6) {
        w = atoi(argv[5]);
    } else {
        fprintf(stderr, "Width: ");
        scanf("%d", &w);
    }
    
    if (argc >= 7) {
        h = atoi(argv[6]);
    } else {
        fprintf(stderr, "Height: ");
        scanf("%d", &h);
    }
    
    /* first just lose some lines */
    for (yi = 0; yi < y; yi++) {
        fgets(line, 10239, fin);
    }
    
    /* now, for each line in the height, make output */
    for (hi = 0; hi < h; hi++) {
        fgets(line, 10239, fin);
        /* within a line, just output the appropriate chunk */
        fprintf(fout, "%.*s\n", w, line + x);
    }
    
    /* done! */
    return 0;
}
